# -*- encoding: utf-8 -*-
from osv import osv, fields
import time
import web
from datetime import date
import gtk

#Clase que representa una balanza
class balanzas_balanza(osv.osv):
    
       _name = 'balanzas.balanza'
       _description = 'Balanza'
       _inherit = ''

       _columns = {
                   
                    'name': fields.char('Dirección IP/Nombre de dominio', size=50, required=True),
                    'puerto': fields.char('Puerto', size=4, required=True),
                    'marca': fields.char('Marca', size=50),
                    'modelo': fields.char('Modelo', size=50),
                    'version': fields.char('Versión', size=50),
                    'vendedores_ids':fields.one2many('balanzas.vendedor', 'balanza_id', 'Vendedores', required=False),
                    'productos_ids':fields.one2many('product.product', 'balanza_id', 'Productos', required = False),
                    'padre' : fields.boolean('Principal', help="La balanza principal es la que sera controlada desde el panel global."),
                    'ventas_diarias_ids':fields.one2many('balanzas.ventas_diarias', 'balanza_id', 'Ventas diarias', required=False),
                    'ventas_totales_ids':fields.one2many('balanzas.ventas_totales', 'balanza_id', 'Ventas totales', required=False),
                    'caja_inicial':fields.float('Caja inicial', digits=(6,2)),
                    'caja_ids':fields.one2many('balanzas.caja', 'balanza_id', 'Caja', required=False)                    
       
       }
       
       def _comprobar_marca(self, cr, user, ids):
            
           #TODO Comprobar marcas modelos y versiones
           
           return True
         
       
       _constraints = [(_comprobar_marca, 'Los datos de la bascula no estan soportados. Escriba en el campo marca \'generica\' para usar una version estandar', ['marca']), ]     

       
           
           
           
                  
       def obtener_vendedores(self, cr, uid, ids, context=None):
           
           cr.execute("SELECT name, puerto FROM balanzas_balanza WHERE id = '" + str(ids[0]) + "'")
           ip_puerto = cr.fetchall()
           #ip_puerto = ip_puerto[0][0] + ':' + ip_puerto[0][1]  + "'" + ip_puerto[0][1]
           ip_puerto = ip_puerto[0][0] + ':' + ip_puerto[0][1] 
           nombres = web.obtener_vendedores(ip_puerto)         
           cr.execute("SELECT name, numero FROM balanzas_vendedor")
           nombres_vendedores = cr.fetchall()
                      
           for i in range(len(nombres_vendedores)):
               
               nombres_vendedores[i] = nombres_vendedores[i][0]              
           
           for i in range(1, len(nombres), 2):
               
               if nombres[i] not in nombres_vendedores:
                                      
                   self.pool.get('balanzas.vendedor').create(cr, uid, {'balanza_id':ids[0], 'name':nombres[i], 'numero':nombres[i -1]})
                   self.pool.get('res.partner').create(cr, uid, {'name':nombres[i]})
                   cr.execute("SELECT id FROM res_partner WHERE name = '" + nombres[i] + "'")
                   id = cr.fetchall()
                   self.pool.get('res.partner.address').create(cr, uid, {'name':nombres[i], 'partner_id':id[0][0]})
                   
       def obtener_productos(self, cr, uid, ids, context):
           
           id_bascula = int(ids[0])
           
           #TODO Obtener productos desde las basculas y los PRECIOS
           #La variable productos sera la forma en que traeremos los datos de la bascula,
           #en la parte izquierda de la tupla el producto, en la derecha la familia.
           cr.execute("SELECT name, puerto FROM balanzas_balanza WHERE id = '" + str(ids[0]) + "'")
           ip_puerto = cr.fetchall()
           #ip_puerto = ip_puerto[0][0] + ':' + ip_puerto[0][1]  + "'" + ip_puerto[0][1]
           ip_puerto = ip_puerto[0][0] + ':' + ip_puerto[0][1] 
           productos = web.obtener_productos(ip_puerto)
           
           #productos = [[u'gambes', u'fruta'], [u'poma', u'fruta'], [u'pepino', u'verdura'], [u'tomate', u'verdura'], [u'creilles', u'verdura'], [u'creill', u'verd']]
           #Echamos un vistazo a las familias
           familias_existentes = []
           familias = []
           productos_existentes_id_categoria = []
           productos_existentes_nombre_categoria = []
           productos_a_borrar = []
           
           #Obtenemos las familias primero                   
           cr.execute('SELECT id FROM product_category')
           ids = cr.fetchall()           

           #Extraemos las familias del SELECT
           for i in range(len(ids)):
               
               if ids[i][0] not in familias_existentes:
                   
                   familias_existentes.append(ids[i][0])
                   
           #Recuperamos product.template en forma de objeto con browse
           #aprovechamos la misma variable
           familias_existentes = self.pool.get('product.category').browse(cr, uid, familias_existentes)
           #Ahora sacamos los nombres
           for i in range(len(familias_existentes)):
               
               familias_existentes[i] = familias_existentes[i].name.lower()
           #Hacemos lo mismo con las posibles familias nuevas
           for i in range(len(productos)):
               
               if productos[i][1].lower() not in familias:
                   
                   familias.append(productos[i][1].lower()) 
               
           #Ya podemos realizar la comparación y añadir las familias nuevas,
           #NO ES Case Sensitive
           for familia in familias:
                              
               if familia.lower() not in familias_existentes:
                   #Si la familia no existe la creamos
                   self.pool.get('product.category').create(cr, uid, {'name':familia})
                   
           #Creamos una familia para productos sin familia
           cr.execute("SELECT id FROM product_category WHERE name = 'ninguna'")
           ids = cr.fetchall()
           if len(ids) == 0:
               
               self.pool.get('product.category').create(cr, uid, {'name':'ninguna'})
               
           #Ahora los productos
           cr.execute('SELECT product_template.name, product_category.name, product_template.list_price\
                       FROM product_template INNER JOIN product_category\
                       ON product_template.categ_id = product_category.id')
           
           productos_existentes = cr.fetchall()
           #productos_existentes es un array exactamente igual a productos
           
           print productos
           print productos_existentes
           ###############################TODO {{{{{{{{{DIFERENCIAR POR BASCULA}}}}}}}}}}}}}}}}##############
           for i in range(len(productos)):               
               
               productos[i][1] = productos[i][1].lower()
               productos[i][0] = productos[i][0].lower()
               for z in range(len(productos_existentes)):
                   
                   #coinciden los nombres
                   if cmp(productos[i][0], productos_existentes[z][0]) == 0:
                       
                       cr.execute("SELECT id FROM product_category WHERE name = '" + productos[i][1] + "'")
                       id_categoria = cr.fetchall()[0][0]
                       cr.execute("SELECT id FROM product_template WHERE name = '" + productos[i][0] + "'")
                       id_producto = cr.fetchall()[0][0]
                       self.pool.get('product.template').write(cr, uid, id_producto, {
                                                                                      'categ_id':id_categoria,
                                                                                      'list_price':productos[i][2].replace(u',', u'.'),
                                                                                      
                                                                                      
                                                                                      })
                       cr.execute("INSERT INTO product_taxes_rel(prod_id, tax_id) VALUES(" + str(id_producto) + ", 34)")
                       
                       break
                   
                   else:
                       
                       #si hemos llegado al final sin que exista
                       
                       if(z == len(productos_existentes) - 1):
                          
                          #lo creamos                          
                          cr.execute("SELECT id FROM product_category WHERE name = '" + productos[i][1] + "'")
                          id_categoria = cr.fetchall()[0][0]
                          
                          self.pool.get('product.product').create(cr, uid, {
                                                                             'name':productos[i][0],
                                                                             'categ_id':id_categoria,
                                                                             'list_price':productos[i][2].replace(u',', u'.'),
                                                                             'balanza_id':id_bascula,
                                                                             'default_code':productos[i][3],
                                                                             'uom_id':2,
                                                                             'uom_po_id':2,
                                                                             
                                                                             })
                      

               #si no hay productos_existentes
               if(len(productos_existentes) == 0):
                  
                  #lo creamos                          
                   cr.execute("SELECT id FROM product_category WHERE name = '" + productos[i][1] + "'")
                   id_categoria = cr.fetchall()[0][0]
                  
                   self.pool.get('product.product').create(cr, uid, {
                                                                     
                                                                     'name':productos[i][0],
                                                                     'categ_id':id_categoria,
                                                                     'list_price':productos[i][2].replace(u',', u'.'),
                                                                     'balanza_id':id_bascula,
                                                                     'default_code':productos[i][3],
                                                                     'uom_id':2,
                                                                     'uom_po_id':2
                                                                     
                                                                     })
                   
           #lo creamos                          
           cr.execute("SELECT id FROM product_category WHERE name = 'ninguna'")
           id_categoria = cr.fetchall()[0][0]
       
           #Vamos a crear el producto 'otros' para el caso de las ventas directas (+E)
           cr.execute("SELECT id FROM product_template WHERE name = 'otros'")
           if len(cr.fetchall()) == 0:
                  
               self.pool.get('product.product').create(cr, uid, {        
                                                                 'name':'otros',
                                                                 'categ_id':id_categoria,
                                                                 'list_price':1.00,
                                                                 'balanza_id':id_bascula,
                                                                 'default_code':'OTR',
                                                                 'uom_id':1,
                                                                 'uom_po_id':1                                                             
                                                                 })
           #Creamos un producto para representar los abonos
           cr.execute("SELECT id FROM product_template WHERE name = 'abonos'")
           if len(cr.fetchall()) == 0:
                  
               self.pool.get('product.product').create(cr, uid, {        
                                                                 'name':'abonos',
                                                                 'categ_id':id_categoria,
                                                                 'list_price':-1.00,
                                                                 'balanza_id':id_bascula,
                                                                 'default_code':'ABO',
                                                                 'uom_id':1,
                                                                 'uom_po_id':1                                                             
                                                                 })
balanzas_balanza()

class balanzas_vista(osv.osv):

    _name = 'balanzas.vista'
    _description = 'zas'
         
    _columns = {
                
            'ventas_diarias_ids':fields.one2many('balanzas.ventas_diarias', 'vista_id', 'Ventas diarias', required=False), 
            'ventas_totales_ids':fields.one2many('balanzas.ventas_totales', 'vista_id', 'Ventas totales', required=False),
            'albaranes_ids':fields.one2many('stock.picking', 'vista_id', 'Albaranes', required=False),
            'caja_ids':fields.one2many('balanzas.caja', 'vista_id', 'Caja', required=False) 
            
    }
       
    def obtener_ventas_diarias(self, cr, uid, ids, context):
                
        cr.execute("SELECT name, puerto, id FROM balanzas_balanza WHERE padre = TRUE")
        ip_puerto = cr.fetchall()
        
        balanza_id = ip_puerto[0][2]
        ip_puerto = ip_puerto[0][0] + ':' + ip_puerto[0][1] 
        
        datos = web.obtener_gran_total_diario(ip_puerto)
        vendedores = datos[0]
        ventas_diarias = datos[1]
        
        for i in range(0, len(ventas_diarias), 3):
            
            cr.execute("SELECT id FROM balanzas_ventas_diarias WHERE date = '" + ventas_diarias[i][0] + "'")
            ventas_ids = cr.fetchall()
                
            self.pool.get('balanzas.ventas_diarias').unlink(cr, uid, ventas_ids)
            
            for z in range(len(vendedores)):
                
                cr.execute("SELECT id FROM balanzas_vendedor WHERE name = '" + vendedores[z] + "'")                
                vendedor_id = cr.fetchall()[0][0]
                                               
                self.pool.get('balanzas.ventas_diarias').create(cr, uid, {'date':ventas_diarias[i][0],
                                                                          'vista_id':ids[0],
                                                                          'balanza_id':balanza_id,
                                                                          'vendedor_id':vendedor_id,
                                                                          'total':ventas_diarias[i][z +1].replace(u',', u'.').strip(),
                                                                          'abonos':ventas_diarias[i + 1][z + 1].replace(u',', u'.').strip(),
                                                                          'neto':ventas_diarias[i + 2][z + 1].replace(u',', u'.').strip()})

    def _calcular_total_tiquets(self, cr, uid, ids, context, ip_puerto):
        
        tiquets = web.obtener_tiquets(ip_puerto)
        cr.execute('SELECT numero FROM balanzas_vendedor')
        vendedores = cr.fetchall()
        for i in range(len(vendedores)):
            
            vendedores[i] = vendedores[i][0]
            
        cr.execute('SELECT date,id  FROM stock_picking')
        fechas_albaranes = cr.fetchall()
        for i in range(len(fechas_albaranes)):
            
            if cmp(str(date.today()).strip(), fechas_albaranes[i][0][0:10].strip()) is 0:
                
                #self.pool.get('stock.picking').unlink(cr, uid, fechas_albaranes[i][1])
                pass
        
        for i in range(len(vendedores)):
            
            aux = []
            
            for z in range(len(tiquets)):
                
                if int(tiquets[z][0]) is i + 1:
                    
                    aux.append(tiquets[z])
                    
            vendedores[i] = aux
                
        for i in range(len(vendedores)):
            
            aux = []
            
            for z in range(len(vendedores[i])):

                afegit = False
                
                if len(aux) is 0:
                    
                    aux.append(vendedores[i][z])
                    continue
                
                for j in range(len(aux)):
                    
                    print vendedores[i][z][2]
                    print aux[j][2]
                    if str(vendedores[i][z][2]).startswith(u'-P') and str(aux[j][2]).startswith(u'-P'):
                    
                        aux[j][4] = float(aux[j][4]) + float(vendedores[i][z][4])
                        afegit = True
                        break
                    if str(vendedores[i][z][2]).startswith(u'+P') and str(aux[j][2]).startswith(u'+P'):
                    
                        aux[j][4] = float(aux[j][4]) + float(vendedores[i][z][4])
                        afegit = True
                        break
                    if cmp(vendedores[i][z][2], u'-E') is 0 and cmp(aux[j][2], u'-E') is 0:
                    
                        aux[j][4] = float(aux[j][4]) + float(vendedores[i][z][4])
                        afegit = True
                        break
                    
                    if cmp(vendedores[i][z][2], u'+E') is 0 and cmp(aux[j][2], u'+E') is 0:
                    
                        aux[j][4] = float(aux[j][4]) + float(vendedores[i][z][4])
                        afegit = True
                        break
                    
                    if str(vendedores[i][z][2]).startswith(u'-P') or str(vendedores[i][z][2]).startswith(u'+P') or str(vendedores[i][z][2]).startswith(u'-E') or str(vendedores[i][z][2]).startswith(u'+E'):
                        continue                       
                    if cmp(vendedores[i][z][3], aux[j][3]) is 0 and cmp(vendedores[i][z][1], aux[j][1]) is 0:
                        
                        aux[j][2] = float(aux[j][2]) + float(vendedores[i][z][2])
                        aux[j][4] = float(aux[j][4]) + float(vendedores[i][z][4])
                        afegit = True
                        break
                    
                if afegit is False:
                    
                    aux.append(vendedores[i][z])
                                    
            vendedores[i] = aux
            
        return vendedores
        
    def obtener_tiquets(self, cr, uid, ids, context):
            
        vista_id = ids[0]
        cr.execute("SELECT name, puerto, id FROM balanzas_balanza WHERE padre = TRUE")
        ip_puerto = cr.fetchall()
        
        balanza_id = ip_puerto[0][2]
        ip_puerto = ip_puerto[0][0] + ':' + ip_puerto[0][1] 
    
        vendedores = self.pool.get('balanzas.vista')._calcular_total_tiquets(cr, uid, ids, context, ip_puerto)
        #print 'HE LLEGADO'    
        #Creación de albaranes       
        for i in range(len(vendedores)):
            
            #Si el vendedor no ha vendido nada pasamos al siguiente
            if len(vendedores[i]) is 0:
                
                continue
            
            #Con esto quitamos el 0 que pome la balanza al numero vendedor (01 -> 1)
            vendedores[i][0][0] = int(vendedores[i][0][0])
            vendedores[i][0][0] = str(vendedores[i][0][0])
            #Cojemos el nombre del vendedor del array en el que estamos
            cr.execute("SELECT name FROM balanzas_vendedor WHERE numero = '" + vendedores[i][0][0] + "'")                        
            nombre = cr.fetchall()[0][0]
            #A traves del nombre cojemos el id del cliente que representa este vendedor
            #para crear facturas. Esto se pude simplificar con una consulta (INNER JOIN). 
            cr.execute("SELECT id FROM res_partner WHERE name = '" + nombre + "'")
            id = cr.fetchall()[0][0]
            #Cojemos la direccion de contacto (virtual) del vendedor representado como un cliente.
            #Lo necesitamos para crear los albaranes que representan las ventas de este vendedor.
            cr.execute("SELECT id FROM res_partner_address WHERE partner_id = '" + str(id) + "'")
            partner = int(cr.fetchall()[0][0])
            #Creamos un 'albaran' (productos salientes en oerp), tiene que ser de tipo 'out'
            
            self.pool.get('stock.picking').create(cr, uid, {
                                                            'address_id':partner,
                                                            'type':'out',
                                                            'invoice_state':'2binvoiced',#Para poder crear fact.
                                                            'vista_id':vista_id,
                                                            'balanza_id':balanza_id
                                                            })
            #Seleccionamos el id de este albaran (sabemos que es el ultimo), para añadirle
            #las lineas de venta
            time.sleep(1)
            cr.execute("SELECT id FROM stock_picking")
            ids = cr.fetchall()
            print ids
        for j in range(len(ids)):
    
            ids[j] = ids[j][0]
    
            ids.sort()
        #print ids
        #print vendedores
        #print vendedores[i]
            id_albaran = ids[len(ids) -1]
            
            id_producto = 0
            #Vamos a recorrer las lineas de ventas para este vendedor. para ir añadiendolas al albaran
            
            for z in range(len(vendedores[i])):
                
                ##########TODO_ COMPROBAR SI ABONOS ESTA CORRECTO#########
                if str(vendedores[i][z][2]).startswith(u'-P'):
                    #print 'detectado -P'
                    cr.execute("SELECT id FROM product_template WHERE name = 'abonos'")
                    id_otros = cr.fetchall()[0][0]
                    self.pool.get('stock.move').create(cr, uid, {
                                                                 'product_id':id_otros,
                                                                 'name':'abonos (-P)',
                                                                 'picking_id':id_albaran,
                                                                 'product_uom':1,
                                                                 'location_id':54,
                                                                 'location_dest_id':54,
                                                                 'product_qty':vendedores[i][z][4],                                                                 
                                                                 })
                    #seguimos con la siguiente linea de venta
                
                    continue
                if cmp(vendedores[i][z][2], u'-E') is 0:
                    #print 'detectado -E'
                    cr.execute("SELECT id FROM product_template WHERE name = 'abonos'")
                    id_otros = cr.fetchall()[0][0]
                    self.pool.get('stock.move').create(cr, uid, {
                                                                 'product_id':id_otros,
                                                                 'name':'abonos (-E)',
                                                                 'picking_id':id_albaran,
                                                                 'product_uom':1,
                                                                 'location_id':54,
                                                                 'location_dest_id':54,
                                                                 'product_qty':vendedores[i][z][4],                                                                 
                                                                 })
                    #seguimos con la siguiente linea de venta
            
                    continue
                if str(vendedores[i][z][2]).startswith(u'+P'):  
                    #print 'detectado +P'
                    #Sabemos que solo hay un 'otros' por vendedor al dia ya que las hemos
                    #agrupado anteriormente. Cojemos el id de producto i creamos la linea.
                    #¿Problemas con el precio final?. Lo que hemos hecho es poner le udv por 
                    #UNIDADES asi ponemos los euros en las unidades y a unidad el euro :-)                                                      
                    cr.execute("SELECT id FROM product_template WHERE name = 'otros'")
                    id_otros = cr.fetchall()[0][0]
                    self.pool.get('stock.move').create(cr, uid, {
                                                                 'product_id':id_otros,
                                                                 'name':'otros (+P)',
                                                                 'picking_id':id_albaran,
                                                                 'product_uom':1,
                                                                 'location_id':54,
                                                                 'location_dest_id':54,
                                                                 'product_qty':vendedores[i][z][4],
                                                                 
                                                                 })
                    #seguimos con la siguiente linea de venta
            
                    continue 
                #Si es una linea de venta directa
                if cmp(vendedores[i][z][1], u'otros') is 0:  
                    #print 'detectado +E'
                    #Sabemos que solo hay un 'otros' por vendedor al dia ya que las hemos
                    #agrupado anteriormente. Cojemos el id de producto i creamos la linea.
                    #¿Problemas con el precio final?. Lo que hemos hecho es poner le udv por 
                    #UNIDADES asi ponemos los euros en las unidades y a unidad el euro :-)                                                      
                    cr.execute("SELECT id FROM product_template WHERE name = 'otros'")
                    id_otros = cr.fetchall()[0][0]
                    self.pool.get('stock.move').create(cr, uid, {
                                                                 'product_id':id_otros,
                                                                 'name':'otros (+E)',
                                                                 'picking_id':id_albaran,
                                                                 'product_uom':1,
                                                                 'location_id':54,
                                                                 'location_dest_id':54,
                                                                 'product_qty':vendedores[i][z][4],
                                                                 
                                                                 })
                    #seguimos con la siguiente linea de venta
            
                    continue 
                
                #Vamos al caso de productos sin nombre
                if cmp(vendedores[i][z][1], 'producto sin nombre') is 0:
                    #print 'detectado producto sin nombre'
                    #Vamos ha comprobar si es un producto sin nombre ya insertado
                    #anteriormente para evitar duplicar datos  
                    cr.execute("SELECT id FROM product_template WHERE name = 'producto sin nombre'\
                    AND list_price = '" + vendedores[i][z][3] + "'")                
                    id_producto = cr.fetchall()
                    #Caso en el que no exista el producto sin nombre todavia
                    if len(id_producto) is 0:                    
                        
                        #Cojemos la categoria ninguna para meter estos productos
                        cr.execute("SELECT id FROM product_category WHERE name = 'ninguna'")
                        id_categ = cr.fetchall()[0][0]
                        #Y creamos el producto con el precio correspondiente
                        self.pool.get('product.product').create(cr, uid, {
                                                                         'name':vendedores[i][z][1],                                         'list_price':vendedores[i][z][3],
                                                                         'balanza_id':balanza_id,
                                                                         'default_code':vendedores[i][z][1],
                                                                         'uom_id':2,
                                                                         'uom_po_id':2,
                                                                         'categ_id':id_categ,
                                                                         'list_price':vendedores[i][z][3]
                                                                         })
                    
                    #Ahora ya tiene que existir el producto sin nombre con este precio asi que vamos a obtener su
                    #id para crear la linea de venta del albaran
                    cr.execute("SELECT id FROM product_template WHERE name = '" + vendedores[i][z][1] + \
                               "' AND list_price = " + vendedores[i][z][3])                
                    id_producto = cr.fetchall()[0][0]                
                    #Ya lo tenemos todo para el caso de productos sin nombre
                    self.pool.get('stock.move').create(cr, uid, {
                                                                 'product_id':id_producto,
                                                                 'name':'producto sin nombre',
                                                                 'picking_id':id_albaran,
                                                                 'product_uom':2,
                                                                 'location_id':54,
                                                                 'location_dest_id':54,
                                                                 'product_qty':vendedores[i][z][2],
                                                                 
                                                                 })
                    #seguimos con la proxima linea
            
                    continue
                #Vamos ahora al caso de productos con nombre. Puede que haya productos con nombre repetido
                #pero al menos su precio de venta tiene que ser diferente para que haya un poco de coherencia.
                #El id producto coincide con el id template asi que con consultar id tempalte sobra.
                #print vendedores[i][z][1]
                #print vendedores[i][z][3]                
                cr.execute("SELECT id FROM product_template WHERE name = '" + vendedores[i][z][1].strip().replace(u' ', u'\xa0') + \
                           "' AND list_price = " + vendedores[i][z][3].strip())
                id_producto = cr.fetchall()
                #Para casos raros no predecidos nos curamos en salud
                if len(id_producto) is 0:
                    
                    print 'No se ha podido encotnrar el id_producto'
                    continue
                id_producto = id_producto[0][0]
                #Creamos la linea
                self.pool.get('stock.move').create(cr, uid, {
                                                             'product_id':id_producto,
                                                             'name':vendedores[i][z][1],
                                                             'picking_id':id_albaran,
                                                             'product_uom':2,
                                                             'location_id':54,
                                                             'location_dest_id':54,
                                                             'product_qty':vendedores[i][z][2],
                                                             
                                                             })
        
    def calcular_caja(self, cr, uid, ids, context):
        
        vista_id = ids[0]
        cr.execute("SELECT name, puerto, id, caja_inicial FROM balanzas_balanza WHERE padre = TRUE")
        ip_puerto = cr.fetchall()
        
        caja_inicial = ip_puerto[0][3]
        balanza_id = ip_puerto[0][2]
        ip_puerto = ip_puerto[0][0] + ':' + ip_puerto[0][1]                 
        caja_final = 0
        
        vendedores = self.pool.get('balanzas.vista')._calcular_total_tiquets(cr, uid, ids, context, ip_puerto)
                
        for i in range(len(vendedores)):
            
            for z in range(len(vendedores[i])):
                
                if cmp(vendedores[i][z][2], u'-E') is 0 or str(vendedores[i][z][2]).startswith(u'-P'):
                    continue
                caja_final += float(vendedores[i][z][4])
        
        caja_final += caja_inicial
        caja_final = round(caja_final, 2)

        self.pool.get('balanzas.caja').create(cr, uid, {
                                                        'caja':caja_final,
                                                        'vista_id':vista_id,
                                                        'balanza_id':balanza_id
                                                        })
               
balanzas_vista()

#Clase que representa a un vendedor
class balanzas_vendedor(osv.osv):

    _name = 'balanzas.vendedor'
    _description = 'Vendedor que pertenece a una bascula'
    #_inherit = 'res.partner'
    
    _columns = {
                            
            'balanza_id':fields.many2one('balanzas.balanza', 'Balanza', required=False),
            'name':fields.char('Nombre', size=20, required=False, readonly=False),
            'numero':fields.char('Numero', size=2, required=False, readonly=False),            
            
    }
    
balanzas_vendedor()

class balanzas_ventas_diarias(osv.osv):

    _name = 'balanzas.ventas_diarias'
    _description = 'Ventas diarias por vendedor'
 
    _columns = {            
                
            'vendedor_id':fields.many2one('balanzas.vendedor', 'Vendedor'),
            'total': fields.float('Total', digits=(6,2)),
            'abonos': fields.float('Abonos', digits=(6,2)),
            'neto': fields.float('Neto', digits=(6,2)),
            'acumulado': fields.float('Acumulado', digits=(6,2)),
            #TODO : import time required to get currect date
            'date': fields.date('Fecha'),
            'vista_id':fields.many2one('balanzas.vista', 'Vista Global', required=False),
            'balanza_id':fields.many2one('balanzas.balanza', 'Balanza', required=False),
              
            
    }
    
    _defaults = {
                   
            'date': lambda *a: time.strftime('%Y-%m-%d'),
          
    }
    
balanzas_ventas_diarias()

class balanzas_caja(osv.osv):

    _name = 'balanzas.caja'
    _description = 'Caja diaria'
 
    _columns = {            
                
            'vendedor_id':fields.many2one('balanzas.vendedor', 'Vendedor'),
            'caja': fields.float('Caja', digits=(6,2)),
            'date': fields.datetime('Fecha y Hora'),
            'vista_id':fields.many2one('balanzas.vista', 'Vista Global', required=False),
            'balanza_id':fields.many2one('balanzas.balanza', 'Balanza', required=False)
            
    }
    
    _defaults = {
                   
            'date': lambda *a: time.strftime('%Y-%m-%d %H:%M'),
          
    }
    
balanzas_caja()
