# -*- encoding: utf-8 -*-
import urllib2
import re
from BeautifulSoup import BeautifulSoup

no_validos = [u'1', u'2', u'3', u'4', u'5', u'6', u'7', u'8', u'9', u'10', u'11'\
              , u'12', u'13', u'14', u'15', u'16', u'17', u'18', u'19', u'20', u'21'\
              , u'22', u'23', u'24', u'25', u'26', u'27', u'28', u'29', u'30', u'31']

 
def obtener_vendedores(direccion):    
    
    direccion = direccion + "/pag235.htm"
    pagina = urllib2.urlopen(direccion).read()    
    pagina = BeautifulSoup(pagina, convertEntities='html')
    tabla_vendedores = pagina("td")
    vendedores = [entry.string for entry in tabla_vendedores if hasattr(entry, 'string')]
    nombres = []
    
    for i in range(len(vendedores)):
        
        vendedores[i] = vendedores[i].replace(u'\xa0', u' ').strip()
                
        if vendedores[i] is u'':
            
            nombres.pop(len(nombres) - 1)
            break
        
        nombres.append(vendedores[i])
    print nombres        
    return nombres

def obtener_productos(direccion):
    
    #Primero las familias
    direccionf = direccion + "/pag236.htm"
    pagina = urllib2.urlopen(direccionf).read()    
    pagina = BeautifulSoup(pagina, convertEntities='html')
    tabla_familias = pagina("td")
    pagina.close()
    familias = [entry.string for entry in tabla_familias if hasattr(entry, 'string')]
    
    #Productos
    direccion = direccion + "/pag238.htm"
    pagina = urllib2.urlopen(direccion).read()    
    pagina = BeautifulSoup(pagina, convertEntities='html')
    pagina.close()
    tabla_productos = pagina("td")
    productos = [entry.string for entry in tabla_productos if hasattr(entry, 'string')]

    #Eliminamos basura
    familias_limpias = []
    for i in range(len(familias)):
        
#       familias[i] = familias[i].replace(u'\xa0', u'')
        if i%2 is not 0:
            
            familias[i] = familias[i].strip(u' ')
        if familias[i] in no_validos or familias[i] is u'':
            
            continue
        
        familias_limpias.append(familias[i])
        
    familias = familias_limpias
          
#    for i in range(len(productos)):
#        
#        productos[i] = productos[i].replace(u'\xa0', u'')
        
    prod_fam = []
        
    for i in range(0, len(productos), 7):
        
        nuevo = []
        nuevo.append(productos[i + 1])
        nuevo.append(familias[int(productos[i + 4])])
        nuevo.append(productos[i + 3])
        nuevo.append(productos[i])
        
        prod_fam.append(nuevo)

    return prod_fam

def obtener_gran_total_diario(direccion):
    
    direccionf = direccion + "/pag12.htm"
    pagina = urllib2.urlopen(direccionf).read()    
    pagina = BeautifulSoup(pagina, convertEntities='html')
    tabla_diario = pagina("td")    
    diario = [entry.string for entry in tabla_diario if hasattr(entry, 'string')]
    tabla_nombres = pagina("th")
    nombres = [entry.string for entry in tabla_nombres if hasattr(entry, 'string')]
    #La primera y la ultima posicion sabemos que no nos valen
    aux = []
    for i in range(1, len(nombres)):
        
        if nombres[i].strip() is u'' or nombres[i].strip() is 'ACUMULADO':
            
            break
        
        aux.append(nombres[i].strip().replace(u'\xa0', u' '))
    nombres = aux
    
      
    diario_nombre = []
    
    for i in range(0, len(diario), 12):
        
        nuevo = []
        nuevo.append(diario[0 + i])
        
        for z in range(1,9):
            
            if diario[z + i] is not u'':
                
                nuevo.append(diario[z + i])
        
        nuevo.append(diario[11 + i])
        
        diario_nombre.append(nuevo)

    #reformateamos las fechas

    for i in range(len(diario_nombre)):
        
        diario_nombre[i] = diario_nombre[i][0:len(nombres) + 1]
        #print diario_nombre[i][0]
        fecha = diario_nombre[i][0].strip(u'Total').strip(u'Abonos').strip(u'Neto').strip().split(u'/')
        fecha = u'20' + fecha[2] + fecha[1] + fecha[0]
        diario_nombre[i][0] = fecha
        
        
        for z in range(len(diario_nombre[i])):
            
            diario_nombre[i][z] = diario_nombre[i][z].strip(u'-').strip()
        
    return [nombres, diario_nombre]

def obtener_tiquets(direccion):
    
    direccion = direccion + "/pag14.htm"    
    pagina = urllib2.urlopen(direccion).read()    
    pagina = BeautifulSoup(pagina, convertEntities='html')
    print pagina
    tabla_tiquets = pagina("h4")
    
    tiquets = [entry.string for entry in tabla_tiquets if hasattr(entry, 'string')]
    
    tiquets = [None] + tiquets
    tiquet_final = []    
    for i in range(len(tiquets)):
        
        if tiquets[i] is not None:
            
            tiquets[i] = tiquets[i].replace(u'\xa0', u' ')
    print tiquets                
    fecha = tiquets[2].strip()
    aux = fecha
    fecha = '20' + aux[12:14] + aux[9:11] + aux[6:8]
    
    patron_inicio_tiquet = re.compile('V[\d]{2}N[\d]{5}')
    patron_fin_tiquet = re.compile('NETO')
    patron_iguales = re.compile('======')
    patron_primera_linea_tiquet = re.compile('OP')
    patron_linea_tiquet = re.compile('[\d],[d]*')
    patron_otros = re.compile('\+E')
    
    producto = ''
    #vamos a obtener los codigos de los vendedores
    vendedor = ''
    producto = ''
    tiene_nombre = False
    for i in range(3, len(tiquets)):
        
        if tiquets[i] is None or patron_iguales.search(tiquets[i]) or\
        patron_primera_linea_tiquet.search(tiquets[i]) or patron_fin_tiquet.search(tiquets[i]):
            
            tiene_nombre = False
            continue
        
        if patron_inicio_tiquet.search(tiquets[i]):
            
            tiene_nombre = False
            vendedor = tiquets[i][1:3].strip()                           
            continue
        
        if patron_otros.search(tiquets[i]):
            
            tiene_nombre = False
            producto = 'otros'
            #print producto
        elif patron_linea_tiquet.search(tiquets[i]) is None:
            
            producto = tiquets[i].strip()
            tiene_nombre = True
            #print tiquets[i]            
            continue
        
        elif tiene_nombre is False:
            
            tiene_nombre = False
            producto = 'producto sin nombre'
            #print producto
        linea = [vendedor, producto, tiquets[i][2:10].replace(',', '.').strip(), tiquets[i][10:18].replace(',', '.').strip(), tiquets[i][18:len(tiquets[i])].replace(',', '.').strip()]
        tiquet_final.append(linea)
        
    return tiquet_final
    